local _
local rematch = Rematch
local old_PLAYER_TARGET_CHANGED = rematch.PLAYER_TARGET_CHANGED
local saved
local settings
local hhh
local doeverywhere
local C_PetJournal = C_PetJournal
rematch:InitModule(function()
	saved = RematchSaved
	settings = RematchSettings
	if not settings.RematchCelestialTournament then
		settings.RematchCelestialTournament = {["do_everywhere"] = false}
	end
	doeverywhere = settings.RematchCelestialTournament.do_everywhere
	----[[
	if saved.RematchCelestialTournament then
		saved.RematchCelestialTournament = nil
	end
	----]]
	--[[
		if not saved.RematchCelestialTournament then
		saved.RematchCelestialTournament = {["do_everywhere"] = false}
	end
	--]]
	
	--doeverywhere = saved.RematchCelestialTournament.do_everywhere
end)
--if temp == 905 then print ("It's Shrine of Seven Stars") end
--if temp == 955 then print ("It's Celestial Tournament") end
--if temp == 903 then print ("It's Shrine of Two Moons") end
--if temp == 976 then print ("It's Horde Garrison") end
--if temp == 321 then print ("It's Orgrimmar") end
local textmessage

local where_to_execute = {
	[955] = {}, --Celestial Tournament
	[1127] = {}, --supposedly, Wailing Caverns pet battle dungeon
	[1137] = {}, --supposedly, The Deadmines pet battle dungeon
}
local function my_PLAYER_TARGET_CHANGED(self)
	--local saved = RematchSaved
	local temp=GetCurrentMapAreaID()
	SetMapToCurrentZone()
	--print(temp)
	--local temp1=GetCurrentMapAreaID()
	--print(temp1)
	--can't make temp1 and temp2 different
	--[[
	local ccount = 0;
	local lastid = 0;
	local mapname
	for i = 1,10000 do
		mapname = GetMapNameByID(i)
		if mapname then
			ccount = ccount + 1
			lastid = i
			if string.find(mapname,"eadmine") or string.find(mapname,"ailing") then
				print(i,mapname)
			end
		end
	end
	print("-------")
	print("number of maps",ccount)
	print("last map id", lastid)
	--]]
	if where_to_execute[temp] or doeverywhere then
		if saved["Heal team"] then
			local healID = saved["Heal team"][1][1]
			local hhealth,hmaxHealth = C_PetJournal.GetPetStats(healID)
			local numDead = 0
			local numInjured = 0
			local numPets = C_PetJournal.GetNumPets()
			if hmaxHealth == hhealth then
				--rematch:LoadTeam("Heal team")
				local most_injured_ID = nil
				local most_injured_deficit = 0
				local least_injured_ID = nil
				local least_injured_deficit = 10000
				for i=1, numPets do
					local petID = C_PetJournal.GetPetInfoByIndex(i)
					if petID then
						local health, maxHealth = C_PetJournal.GetPetStats(petID)
						if health == 0 then numDead = numDead + 1 end
						if health < maxHealth and health > 0 then
							local deficit = maxHealth - health
							numInjured = numInjured + 1
							if most_injured_deficit < deficit then
								most_injured_ID = petID
								most_injured_deficit = deficit
							end
							if least_injured_deficit > deficit then
								least_injured_ID = petID
								least_injured_deficit = deficit
							end
						end
					end
				end
				if numInjured > 0 then
					C_PetJournal.SetPetLoadOutInfo(1, healID)
					C_PetJournal.SetPetLoadOutInfo(2, most_injured_ID)
					if numInjured > 1 then
						C_PetJournal.SetPetLoadOutInfo(3, least_injured_ID)
					end
				end
				--print(format("You have %s injured pets and %s dead pets.",tostring(numInjured),tostring(numDead)))
			else --you asked for this by letting your healing pet to get injured
				hhh = {}
				for i=1, numPets do
					local petID = C_PetJournal.GetPetInfoByIndex(i)
					if petID then
						local health,maxHealth = C_PetJournal.GetPetStats(petID)
						if health == 0 then numDead = numDead + 1 end
						if health < maxHealth and health > 0 then
							numInjured = numInjured + 1
							hhh[numInjured] = petID
						end
					end
				end
				if hhealth == 0 then
					DEFAULT_CHAT_FRAME:AddMessage("Pet intended to do the healing is dead")
				else
					for i=1, 3 do
						C_PetJournal.SetPetLoadOutInfo(i, hhh[i])
					end
					C_PetJournal.SetPetLoadOutInfo(1, healID)
				end
				--print(format("You have %s injured pets and %s dead pets.",tostring(numInjured),tostring(numDead)))
			end
			DEFAULT_CHAT_FRAME:AddMessage("You have " .. numInjured .. " injured pets and " .. numDead .. "dead pets." )
			--print(format("You have %s injured pets and %s dead pets.",tostring(numInjured),tostring(numDead))) --printing here doesn't seem to work
			if numInjured == 0 then
				local name,npcID = rematch:GetUnitNameandID("target")
				if saved[npcID] then
					DEFAULT_CHAT_FRAME:AddMessage("Since there are no injured pets, loaded team for " .. name)
					rematch:LoadTeam(npcID)
				end
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("Healing team not defined")
		end
	else
		SetMapByID(temp)
		--GetRealZoneText()
		local tst = GetMapInfo()
		if not textmessage then
			local commonids = ""
			local commonnames = ""
			--[[
			for zoneid,_ in pairs(where_to_execute) do
				local place = GetMapNameByID(zoneid)
				commonids = commonids .. zoneid .. ", "
				commonnames = commonnames .. place .. ", "
			end
			--]]
			for zoneid,_ in pairs(where_to_execute) do
				local place = GetMapNameByID(zoneid)
				commonids = commonids .. ", " .. zoneid
				commonnames = commonnames .. ", " .. place
			end
			textmessage = ", a loading of different team for healing is meant for zones with ID " .. commonids .. " - " .. commonnames .."."
			textmessage = textmessage:gsub(" , "," ")
		end
		DEFAULT_CHAT_FRAME:AddMessage("It's " .. GetRealZoneText() .. " or " .. tst .. " with zone ID " .. temp .. textmessage)
	end
end

function rematch:PLAYER_TARGET_CHANGED()
	if IsShiftKeyDown() then
		local name,npcID = rematch:GetUnitNameandID("target")
		if saved[npcID] then
			DEFAULT_CHAT_FRAME:AddMessage("There's a saved team meant for defeating " .. name)
		end
		--rematch.recentTarget = nil
		return my_PLAYER_TARGET_CHANGED(self)
	else
		return old_PLAYER_TARGET_CHANGED(self)
	end
end

SLASH_RMTCELEST1 = "/rmtcelest";
function SlashCmdList.RMTCELEST(msg)
	local wasnotrecognized = true
	if msg =="status" then
		wasnotrecognized = false
		if doeverywhere then
			DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team is currently enabled for each zone")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team is currently enabled only in Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon")
		end
	end
	if msg == "on" then
		wasnotrecognized = false
		doeverywhere = true
		settings.RematchCelestialTournament.do_everywhere = doeverywhere
		DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was enabled for each zone")
	end
	if msg == "off" then
		wasnotrecognized = false
		doeverywhere = false
		settings.RematchCelestialTournament.do_everywhere = doeverywhere
		DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was enabled to only Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon")
	end
	if msg == "toggle" then
		wasnotrecognized = false
		doeverywhere = not doeverywhere
		settings.RematchCelestialTournament.do_everywhere = doeverywhere
		if doeverywhere then
			DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was toggled to be enabled in every zone")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was toggled to be enabled only in Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon")
		end
	end
	if msg == "reset" then
		wasnotrecognized = false
		doeverywhere = false
		settings.RematchCelestialTournament.do_everywhere = doeverywhere
		DEFAULT_CHAT_FRAME:AddMessage("Loading of healing team was reset to be enabled only in Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon")
	end
	if wasnotrecognized then
		DEFAULT_CHAT_FRAME:AddMessage("Available comands:")
	--if msg == "" or wasnotrecognized then
		DEFAULT_CHAT_FRAME:AddMessage(" /rmtcelest status - Displays current status of loading of healing team")
		DEFAULT_CHAT_FRAME:AddMessage(" /rmtcelest on - Enables loading of healing team in every zone")
		DEFAULT_CHAT_FRAME:AddMessage(" /rmtcelest off - Enables loading of healing team only in Celestial Tournament, Wailing Caverns pet battle dungeon and The Deadmines pet battle dungeon")
		DEFAULT_CHAT_FRAME:AddMessage(" /rmtcelest toggle - Toggles status of loading of healing team")
		DEFAULT_CHAT_FRAME:AddMessage(" /rmtcelest reset - Resets status of loading of healing team")
	end
end




